(defvar pvs-menu
  '("PVS"
    ("Getting Help"
     ["help-pvs" help-pvs t]
     ["help-pvs-language" help-pvs-language t]
     ["help-pvs-prover" help-pvs-prover t])
    ["parse" parse t]
    ["typecheck" typecheck t]
    ["typecheck-prove" typecheck-prove t]
    ["prove" prove t]
    ("Prove ..."
     ["redo-proof" redo-proof t]
     ["prove-theory" prove-theory t]
     ["prove-pvs-file" prove-pvs-file t]
     ["prove-importchain" prove-importchain t]
     ["prove-proofchain" prove-proofchain t])
    ("Proof Editing"
     ["edit-proof" edit-proof t]
     ["install-proof" install-proof t]
     ["revert-proof" revert-proof t]
     ["show-proof-file" show-proof-file t]
     ["show-orphaned-proofs" show-orphaned-proofs t])
    ("Proof Information"
     ["show-proof" show-proof t]
     ["show-last-proof" show-last-proof t]
     ["ancestry" ancestry t]
     ["siblings" siblings t]
     ["show-hidden-formulas" show-hidden-formulas t]
     ["show-auto-rewrites" show-auto-rewrites t])
    ("Modify Specification"
     ["add-declaration" add-declaration t]
     ["modify-declaration" modify-declaration t])
    ("Prettyprint"
     ["prettyprint-theory" prettyprint-theory t]
     ["prettyprint-pvs-file" prettyprint-pvs-file t]
     ["prettyprint-declaration" prettyprint-declaration t]
     ["prettyprint-region" prettyprint-region t])
    ("Viewing TCCs"
     ["show-tccs" show-tccs t]
     ["prettyprint-expanded" prettyprint-expanded t])
    ("Files and Theories"
     ["find-pvs-file" find-pvs-file t]
     ["find-theory" find-theory t]
     ["view-prelude-file" view-prelude-file t]
     ["view-prelude-theory" view-prelude-theory t]
     ["new-pvs-file" new-pvs-file t]
     ["new-theory" new-theory t]
     ["import-pvs-file" import-pvs-file t]
     ["import-theory" import-theory t]
     ["delete-pvs-file" delete-pvs-file t]
     ["delete-theory" delete-theory t]
     ["save-file" save-file t]
     ["save-some-pvs-files" save-some-pvs-files t]
     ["dump-pvs-files" dump-pvs-files t]
     ["undump-pvs-files" undump-pvs-files t])
    ("Printing"
     ["pvs-print-buffer" pvs-print-buffer t]
     ["pvs-print-region" pvs-print-region t]
     ["print-theory" print-theory t]
     ["print-pvs-file" print-pvs-file t]
     ["print-importchain" print-importchain t]
     ["alltt-theory" alltt-theory t]
     ["alltt-pvs-file" alltt-pvs-file t]
     ["alltt-importchain" alltt-importchain t]
     ["latex-theory" latex-theory t]
     ["latex-pvs-file" latex-pvs-file t]
     ["latex-importchain" latex-importchain t]
     ["latex-proof" latex-proof t]
     ["latex-theory-view" latex-theory-view t])
    ("Context"
     ["list-pvs-files" list-pvs-files t]
     ["list-theories" list-theories t]
     ["change-context" change-context t]
     ["save-context" save-context t]
     ["context-path" context-path t])
    ("Browse"
     ["show-declaration" show-declaration t]
     ["find-declaration" find-declaration t]
     ["whereis-declaration-used" whereis-declaration-used t]
     ["list-declarations" list-declarations t])
    ("Status"
     ["status-theory" status-theory t]
     ["status-pvs-file" status-pvs-file t]
     ["status-importchain" status-importchain t]
     ["importchain" importchain t]
     ["importbychain" importbychain t]
     ["status-proof" status-proof t]
     ["status-proof-theory" status-proof-theory t]
     ["status-proof-importchain" status-proof-importchain t]
     ["status-proofchain" status-proofchain t])
    ("Environment"
     ["whereis-pvs" whereis-pvs t]
     ["pvs-version" pvs-version t]
     ["pvs-mode" pvs-mode t]
     ["remove-popup-buffer" remove-popup-buffer t]
     ["pvs-status" pvs-status t]
     ["keyboard-quit" keyboard-quit t]
     ["reset-pvs" reset-pvs t])
    ("Miscellaneous"
     ["forward-theory" forward-theory t]
     ["backward-theory" backward-theory t]
     ["find-unbalanced-pvs" find-unbalanced-pvs t]
     ["comment-region" comment-region t])
    ("Exiting"
     ["suspend-pvs" suspend-pvs t]
     ["exit-pvs" exit-pvs t])))

(defun pvs-install-menubar ()
  (if (and current-menubar (not (assoc "PVS" current-menubar)))
      (let ((menu (if (eq major-mode 'pvs-mode)
		      pvs-menu
		      (error "not PVS mode"))))
	(set-buffer-menubar (copy-sequence current-menubar))
	(add-menu nil "PVS" (cdr menu)))))

(add-hook 'pvs-mode-hook 'pvs-install-menubar)
